package com.iformall.domain.po;

import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @author gongbiao
 */
@Table(name = "wx_brand")
public class WxBrand implements Serializable {
	private static final long serialVersionUID = 1L;
	
	@Id
    protected Long id;
    
    @Transient
    protected List<Long> ids;
    @Transient
    protected String sortColumns;
  
	public Long getId() {
		return id;
	}
	public void setId(Long id) {
		this.id = id;
	}
	public String getSortColumns() {
		return sortColumns;
	}
	 
	public List<Long> getIds() {
		return ids;
	}
	public void setIds(List<Long> ids) {
		this.ids = ids;
	}

	@io.swagger.annotations.ApiModelProperty(value="tenantId",name="tenantId")
	private String tenantId;
	
	@io.swagger.annotations.ApiModelProperty(value="名称",name="name")
	private String name;

	@io.swagger.annotations.ApiModelProperty(value="创建时间",name="createtime")
	private Date createtime;

	@io.swagger.annotations.ApiModelProperty(value="修改时间",name="updatetime")
	private Date updatetime;

	@io.swagger.annotations.ApiModelProperty(value = "Logo", name = "logo")
    private String logo;

	@io.swagger.annotations.ApiModelProperty(value = "简介", name = "summary")
    private String summary;

	@io.swagger.annotations.ApiModelProperty(value = "创始时间", name = "createdate")
	private Date createdate;

	public String  getName() {
		return name;
	}
	public void setName(String _name) {
		name = _name;
	}
	public Date  getCreatetime() {
		return createtime;
	}
	public void setCreatetime(Date _createtime) {
		createtime = _createtime;
	}
	public Date  getUpdatetime() {
		return updatetime;
	}
	public void setUpdatetime(Date _updatetime) {
		updatetime = _updatetime;
	}

	public String getTenantId() {
		return tenantId;
	}

	public void setTenantId(String tenantId) {
		this.tenantId = tenantId;
	}

    public String getLogo() {
		return logo;
	}

    public void setLogo(String logo) {
		this.logo = logo;
	}

    public String getSummary() {
		return summary;
	}

    public void setSummary(String summary) {
		this.summary = summary;
	}

	public Date getCreatedate() {
		return createdate;
	}

	public void setCreatedate(Date createdate) {
		this.createdate = createdate;
	}

	public static enum Field
	{
		Id_ASC("`id` ASC"),Id_DESC("`id` DESC")
			,Name_ASC("`name` ASC"),Name_DESC("`name` DESC")
			,Createtime_ASC("`createtime` ASC"),Createtime_DESC("`createtime` DESC")
			,Updatetime_ASC("`updatetime` ASC"),Updatetime_DESC("`updatetime` DESC")
	;
		private String value;
		Field(String value){
			this.value = value;
		}
		public String getValue() {
			return value;
		}
		public void setCol(String value) {
			this.value = value;
		}
		@Override
		public String toString() {
			return this.getValue();
		}
	}
	
	public void setSortColumns(Field... fields)
	{
		if (fields == null || fields.length == 0) {
			return;
		}
		for (int k = 0; k < fields.length; k++) {
			if (fields[k] == null) {
				return;
			}
		}
		StringBuilder sb = new StringBuilder(fields[0].toString());
		for (int k = 1; k < fields.length; k++) {
			sb.append(",");
			sb.append(fields[k].toString());
		}
		this.sortColumns = sb.toString();
	}
	
	public void setSortColumns(String sortColumns)
	{
		if (sortColumns == null || "".equals(sortColumns.trim())) {
			return;
		}
		if (sortColumns.contains(",")) {
			String[] cols = sortColumns.split(",");
			List<Field> fList = new ArrayList();
			for (int k = 0; k < cols.length; k++) {
				fList.add(Field.valueOf(cols[k]));
			}
			this.setSortColumns(fList.toArray(new Field[fList.size()]));
		} else {
			this.setSortColumns(Field.valueOf(sortColumns));
		}
	}
}
